#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <ctype.h>

#include <iptables.h>
#include <net/if.h>

#define NIPQUAD(addr) \
	((unsigned char *)&addr)[0], \
	((unsigned char *)&addr)[1], \
	((unsigned char *)&addr)[2], \
	((unsigned char *)&addr)[3]

struct ipt_spiDoS
{
	char net_iface[IFNAMSIZ];

	/* the network address of the router's LAN such as '192.168.1.0' */
	unsigned int lan_netaddr;

	unsigned int lan_netmask;

	/* 
	 * Echo port (port 7) and Chargen port (port 19) are explicitly requested 
	 * by Port Forwarding or Port Triggering or NOT ?
	 */
	unsigned int drop_echo_chargen;
};

static void help(void)
{
}

static void init(struct ipt_entry_match *m, unsigned int *nfcache)
{
}

static int parse(int c, char **argv, int invert, unsigned int *flags,
		const struct ipt_entry *entry,
		unsigned int *nfcache,
		struct ipt_entry_match **match)
{
	printf("use net-wall instead!\n");
	return 1;
}

static void final_check(unsigned int flags)
{
}

static void print(const struct ipt_ip *ip,
		const struct ipt_entry_match *match,
		int numeric)
{
	struct ipt_spiDoS *dos;

	dos = (struct ipt_spiDoS *)match->data;

	printf("spiDoS wan:%s, addr:%u.%u.%u.%u, mask:%u.%u.%u.%u, chargen:0x%08X",
			dos->net_iface, NIPQUAD(dos->lan_netaddr), NIPQUAD(dos->lan_netmask),
			dos->drop_echo_chargen);
}

static void save(const struct ipt_ip *ip, const struct ipt_entry_match *match)
{
}

static struct iptables_match spiDoS = { 
	.next           = NULL,
	.name           = "spiDoS",
	.size           = IPT_ALIGN(sizeof(struct ipt_spiDoS)),
	.userspacesize  = IPT_ALIGN(sizeof(struct ipt_spiDoS)),
	.version        = IPTABLES_VERSION,
	.help           = &help,
	.init           = &init,
	.parse          = &parse,
	.final_check    = &final_check,
	.print          = &print,
	.save           = &save,
};

void _init(void)
{
	register_match(&spiDoS);
}

